#include "act/controller.h"
#include "act/root.h"
#include "allocate/factory.h"
#include "code/return.h"
#include "draw/window_service.h"

root_controller_t::root_controller_t(
	root_controller_t::configuration_t* configuration_p
) {
	configuration_m = configuration_p;
}

void_t<controller_t::error_t> root_controller_t::on_event(
	controller_t::event_t event_p
) {
	text_service_t* text_service_l = configuration_m->provider_m->configuration_m->text_service_m;
	text_service_l->initialize(
	);
	std::string window_title = text_service_l->get_text(
		text_service_t::text_t::window_title
	).value_m;
	configuration_m->provider_m->configuration_m->window_service_m->create_window(
		&window_title
	);
	void_t<controller_t::error_t> void_l;
	void_l.error_m = controller_t::error_t::none;
	return void_l;
}

return_t<root_controller_t::error_t, root_controller_t*> root_controller_factory_t::create(
	root_controller_t::configuration_t* configuration_p
) {
	return_t<root_controller_t::error_t, root_controller_t*> return_l;
	return_l.error_m = root_controller_t::error_t::none;
	return_l.value_m = new root_controller_t(configuration_p);
	return return_l;
}

void_t<root_controller_t::error_t> root_controller_factory_t::dispose(
	root_controller_t* root_controller_p
) {
	delete root_controller_p;
	void_t<root_controller_t::error_t> return_l;
	return_l.error_m = root_controller_t::error_t::none;
	return return_l;
}
