#include "code/observable.h"
#include "code/return.h"

template <class V> observable_t<V>::observable_t(
	observable_t::configuration_t* configuration_p
) {
	configuration_m = configuration_p;
}

template <class V> void observable_t<V>::observe(
	observer_t<V>* observer_p
) {
	observer_p->on_change(configuration_m->value_m);
	observers_m.push_back(observer_p);
}

template <class V> void_t<observable_t::error_t> observable_t<V>::unobserve(
	observer_t<V>* observer_p
) {
	observable_t::error_t error_l = observable_t::error_t::not_observing;
	for (int i = 0; i < observers_m.size(); i++) {
		if (observers_m[i] == observer_p) {
			observers_m.erase(i);
			error_l = observable_t::error_t::none;
			break;
		}
	}
	void_t<observable_t::error_t> void_l;
	void_l.error_m = error_l;
	return void_l;
}

template <class V> V observable_t<V>::get_value(
) {
	return value_m;
}

template <class V> void_t<observable_t::error_t> observable_t<V>::change(
	V* value_p
) {
	configuration_m->value_m = value_p;
	for (int i = 0; i < observers_m.size(); i++) {
		observer_m = observers_m[i];
		observer_m->on_change(configuration_m->value_m);
	}
	void_t<observable_t::error_t> void_l;
	void_l.error_m = observable_t::error_t::none;
	return void_l;
}

template <class V> return_t<observable_t::error_t, observable_t*> observable_factory_t<V>::create(
	observable_t::configuration_t* configuration_p
) {
	observable_t<V>* observable_l = new observable_t<V>(
		configuration_p
	);
	return_t<observable_t::error_t, observable_t*> return_l;
	return_l.error_m = observable_t::error_t::none;
	return_l.value_m = observable_l;
	return return_l;
}
