#include "fabricate/model_service.h"
#include "code/return.h"
#include <string>

model_service_t::model_service_t(
	model_service_t::configuration_t* configuration_p
) {
	configuration_m = configuration_p;
}

return_t<model_service_t::error_t, model_t*> get_model_by_id(
	model_service_t::model_id_t model_id_p
) {
	model_t* model_l;
	switch (model_id_p) {
		case model_service_t::model_id_t::monkey:
			// model_l = new model with correct data
			break;
		default:
			model_l = nullptr;
			break;
	}
	return_t<model_service_t::error_t, model_t*> return_l;
	return_l.error_m = model_service_t::error_t::none;
	return_l.value_m = model_l;
	return return_l;
}

return_t<model_service_t::error_t, model_service_t*> create(
	model_service_t::configuration_t* configuration_p
) {
	model_service_t* model_service_l = new model_service_t(
		configuration_p
	);
	return_t<model_service_t::error_t, model_service_t*> return_l;
	return_l.error_m = model_service_t::error_t::none;
	return_l.value_m = model_service_l;
	return return_l;
}

void_t<model_service_t::error_t> dispose(
	model_service_t* model_service_p
) {
	delete model_service_p;
	void_t<model_service_t::error_t> void_l;
	void_l.error_m = model_service_t::error_t::none;
	return void_l;
}
